{
    Model-GUI-Mediator demo

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    Description:
      This unit is part of the Model-GUI-Mediator article written for
      the Toolbox Magazine. To compile this project you need FPC 2.2.0
      or later and the fpGUI Toolkit (http://fpgui.sourceforge.net/).
}

unit views;

{$mode objfpc}{$H+}

interface

uses
  model, mediators;

type

  TContactNameEditView = class(TEditMediator)
  protected
    procedure DoGuiToObject; override;
    procedure DoObjectToGui; override;
  end;


  TContactNamePanelView = class(TPanelMediator)
  protected
    procedure DoObjectToGui; override;
  end;


  TContactAddressMemoView = class(TMemoMediator)
  protected
    procedure DoGuiToObject; override;
    procedure DoObjectToGui; override;
  end;


  TContactDateOfBirthEditView = class(TCalendarMediator)
  protected
    procedure DoGuiToObject; override;
    procedure DoObjectToGui; override;
  end;


implementation


{ TContactNameEditView }

procedure TContactNameEditView.DoGuiToObject;
begin
  inherited DoGuiToObject;
  TContact(Subject).Name := GUIControl.Text;
end;

procedure TContactNameEditView.DoObjectToGui;
begin
  inherited DoObjectToGui;
  GUIControl.Text := TContact(Subject).Name;
end;


{ TContactNamePanelView }

procedure TContactNamePanelView.DoObjectToGui;
begin
  inherited DoObjectToGui;
  GUIControl.Text := TContact(Subject).Name;
end;


{ TContactAddressMemoView }

procedure TContactAddressMemoView.DoGuiToObject;
begin
  inherited DoGuiToObject;
  TContact(Subject).Address := GUIControl.Text;
end;

procedure TContactAddressMemoView.DoObjectToGui;
begin
  inherited DoObjectToGui;
  GUIControl.Text := TContact(Subject).Address;
end;


{ TContactDateOfBirthEditView }

procedure TContactDateOfBirthEditView.DoGuiToObject;
begin
  inherited DoGuiToObject;
  TContact(Subject).DateOfBirth := GUIControl.DateValue;
end;

procedure TContactDateOfBirthEditView.DoObjectToGui;
begin
  inherited DoObjectToGui;
  GUIControl.DateValue := TContact(Subject).DateOfBirth;
end;


end.

